'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {

  /**
   * @param {Logger} logger logger class
   */
  function _class(logger) {
    _classCallCheck(this, _class);

    this.configPath = _path2.default.join(__dirname, '../..', 'config.json');
    this.logger = logger;
  }

  _createClass(_class, [{
    key: 'listConfig',
    value: function listConfig(configLocation) {
      var _this = this;

      this.logger.log('Config location: ' + configLocation);
      _fs2.default.readFile(configLocation, function (err, configData) {
        _this.logger.log("Config:\n", JSON.parse(configData));
      });
    }
  }, {
    key: 'updateProp',
    value: function updateProp(property, value) {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        var propArgs = property.split('.');

        _fs2.default.readFile(_this2.configPath, function (err, file) {
          if (err) {
            reject("Could not update config:" + err);
            return 1;
          }

          var config = JSON.parse(file);
          switch (propArgs.length) {
            case 1:
              if (config.hasOwnProperty(propArgs[0]) && _typeof(config[propArgs[0]]) !== 'object') {
                config[propArgs[0]] = _this2.convertValue(value);
                break;
              }
              reject("Unknown property: " + property);
              break;
            case 2:
              if (config.hasOwnProperty(propArgs[0])) {
                if (config[propArgs[0]].hasOwnProperty(propArgs[1]) && _typeof(config[propArgs[0]][propArgs[1]]) !== 'object') {
                  config[propArgs[0]][propArgs[1]] = _this2.convertValue(value);
                  break;
                }
              }
              reject("Unknown property: " + property);
              break;
            case 3:
              if (config.hasOwnProperty(propArgs[0])) {
                if (config[propArgs[0]].hasOwnProperty(propArgs[1])) {
                  if (config[propArgs[0]][propArgs[1]].hasOwnProperty(propArgs[2])) {
                    config[propArgs[0]][propArgs[1]][propArgs[2]] = _this2.convertValue(value);
                    break;
                  }
                }
                reject("Unknown property: " + property);
              }
              reject("Unknown property: " + property);
              break;
            default:
              reject("Unknown property: " + property);
          }

          _fs2.default.writeFile(_this2.configPath, JSON.stringify(config, null, 2), function () {
            reject("Property: '" + property + "' has been updated: " + value);
            resolve(0);
          });
        });
      }).catch(function (err) {
        return _this2.logger.log(err);
      });
    }
  }, {
    key: 'convertValue',
    value: function convertValue(value) {
      if (value === 'true') {
        return true;
      } else if (value === 'false') {
        return false;
      } else if (!isNaN(value)) {
        return parseInt(value, 10);
      }
      return value;
    }
  }]);

  return _class;
}();

exports.default = _class;