'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _child_process = require('child_process');

var _child_process2 = _interopRequireDefault(_child_process);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {

  /**
   * @param {Object} config config for ap-npm
   * @param {Logger} logger Logger class
   */
  function _class(config, logger) {
    _classCallCheck(this, _class);

    this.host = config.hostname;
    this.port = config.port;
    this.ssl = config.ssl.enabled;
    this.logger = logger;
  }

  _createClass(_class, [{
    key: 'run',
    value: function run(pathToProject) {
      var _this = this;

      return new Promise(function (resolve) {
        var spawn = _child_process2.default.spawnSync;
        var shell = function shell(cmd, opts) {
          process.stdin.pause();
          return spawn(cmd, opts, {
            stdio: [0, 1, 2]
          });
        };
        resolve(shell('npm', ['init']));
      }).then(function () {
        _fs2.default.readFile(_path2.default.join(pathToProject, 'package.json'), function (err, file) {
          var publishConfig = void 0;
          if (err !== null) {
            _this.logger.warn(err);
            return;
          }

          if (_this.ssl) {
            publishConfig = {
              "registry": "https://" + _this.host + ':' + _this.port
            };
          } else {
            publishConfig = {
              "registry": "http://" + _this.host + ':' + _this.port
            };
          }
          _this.logger.info('\nUpdating package.json with publishConfig:', publishConfig);
          var packageJson = JSON.parse(file);
          packageJson.publishConfig = publishConfig;
          _fs2.default.writeFile(_path2.default.join(pathToProject, 'package.json'), JSON.stringify(packageJson, null, 2), { 'mode': '0664' }, function () {
            _this.logger.info("ap-npm project created in: " + pathToProject + '\n');
          });
        });
      });
    }
  }]);

  return _class;
}();

exports.default = _class;