'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (configFile) {
  var container = new _container2.default();

  container.set('config', function () {
    return require(configFile);
  });

  container.set('logger', function () {
    var Logger = require('./util/logger').default;
    return new Logger();
  });

  (0, _storageInit2.default)(container);
  (0, _routesInit2.default)(container);
  (0, _authInit2.default)(container);
  (0, _commandInit2.default)(container);
  (0, _utilInit2.default)(container);
  (0, _adminInit2.default)(container);

  return container;
};

var _container = require('./util/container');

var _container2 = _interopRequireDefault(_container);

var _storageInit = require('./init/storage-init');

var _storageInit2 = _interopRequireDefault(_storageInit);

var _routesInit = require('./init/routes-init');

var _routesInit2 = _interopRequireDefault(_routesInit);

var _authInit = require('./init/auth-init');

var _authInit2 = _interopRequireDefault(_authInit);

var _commandInit = require('./init/command-init');

var _commandInit2 = _interopRequireDefault(_commandInit);

var _utilInit = require('./init/util-init');

var _utilInit2 = _interopRequireDefault(_utilInit);

var _adminInit = require('./init/admin-init');

var _adminInit2 = _interopRequireDefault(_adminInit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }