'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (container) {
  container.set('route-admin', function () {
    var Route = require('../routes/admin').default;
    return new Route();
  });

  container.set('route-admin-all', function () {
    var Route = require('../routes/admin-all').default;
    return new Route(container.get('storage'));
  });

  container.set('route-admin-config', function () {
    var Route = require('../routes/admin-config').default;
    return new Route(container.get('config'));
  });

  container.set('admin-access', function () {
    var AdminAccess = require('../admin/admin-access').default;
    return new AdminAccess(container.get('auth'));
  });
};