'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (container) {
  container.set('route-package-get-json', function () {
    var Route = require('../routes/package-get-json').default;
    return new Route(container.get('storage'), container.get('proxy'), container.get('config').proxyEnabled);
  });

  container.set('route-package-publish', function () {
    var Route = require('../routes/package-publish').default;
    return new Route(container.get('storage'), container.get('validator'));
  });

  container.set('route-package-get', function () {
    var Route = require('../routes/package-get').default;
    return new Route(container.get('storage'), container.get('validator'));
  });

  container.set('route-package-delete', function () {
    var Route = require('../routes/package-delete').default;
    return new Route(container.get('storage'), container.get('validator'), container.get('config'));
  });

  container.set('route-package-get-dist-tags', function () {
    var Route = require('../routes/package-get-dist-tags').default;
    return new Route(container.get('storage'));
  });

  container.set('route-package-delete-dist-tags', function () {
    var Route = require('../routes/package-delete-dist-tags').default;
    return new Route(container.get('storage'));
  });

  container.set('route-package-add-dist-tags', function () {
    var Route = require('../routes/package-add-dist-tags').default;
    return new Route(container.get('storage'));
  });
};