'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(storage) {
    _classCallCheck(this, _class);

    this.storage = storage;
  }

  /**
   * @param {class} httpRequest req
   * @param {class} httpResponse res
   * @return {void} -
   */


  _createClass(_class, [{
    key: 'process',
    value: function process(httpRequest, httpResponse) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var packageName = httpRequest.body._packageName;
        var packageScope = httpRequest.body._scope;
        var distTag = httpRequest.body._disttag;

        _this.storage.getPackageJson({
          name: packageName,
          scope: packageScope
        }).catch(function (err) {
          httpResponse.status(404);
          httpResponse.send(err);
        }).then(function (packageJson) {
          if ((typeof packageJson === 'undefined' ? 'undefined' : _typeof(packageJson)) === 'object') {
            delete packageJson['dist-tags'][distTag];
            _this.storage.updatePackageJson({
              name: packageName,
              scope: packageScope
            }, packageJson).then(function (result) {
              if (result === true) {
                httpResponse.status(200);
                resolve(httpResponse.send({
                  ok: "dist-tags updated"
                }));
              } else {
                reject("Could not get dist-tags");
              }
            });
          } else {
            reject("Could not get dist-tags");
          }
        });
      }).catch(function (err) {
        httpResponse.status(404);
        httpResponse.send(err);
      });
    }
  }]);

  return _class;
}();

exports.default = _class;