"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(storage, validator) {
    _classCallCheck(this, _class);

    this.storage = storage;
    this.packageValidator = validator;
  }

  /**
   * @param {class} httpRequest req
   * @param {class} httpResponse res
   * @return {void} -
   */


  _createClass(_class, [{
    key: "process",
    value: function process(httpRequest, httpResponse) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        var packageData = httpRequest.body;
        var packageName = packageData._packageName;
        var packageScope = packageData._scope;

        if (!packageData._attachments) {
          _this.deprecateUpdater(packageData).then(function (result) {
            if (result) {
              httpResponse.status(200).send({
                ok: "packageJson updated"
              });
              resolve();
            } else {
              reject("420, error: cannot update");
            }
          });
        }

        _this.storage.isPackageAvailable({
          name: packageName,
          scope: packageScope
        }).then(function (available) {
          if (available === true) {
            return _this.writePackage(httpRequest, httpResponse);
          } else {
            return _this.writeNewPackage(httpRequest, httpResponse);
          }
        });
      }).catch(function (err) {
        httpResponse.send(err);
      });
    }
  }, {
    key: "deprecateUpdater",
    value: function deprecateUpdater(packageData) {
      var _this2 = this;

      return new Promise(function (resolve) {
        _this2.storage.updatePackageJson({
          name: packageData._packageName,
          scope: packageData._scope
        }, packageData).then(function (data) {
          resolve(data);
        });
      });
    }

    /**
     * @param {class} httpRequest req
     * @param {class} httpResponse res
     * @return {void} -
     */

  }, {
    key: "writePackage",
    value: function writePackage(httpRequest, httpResponse) {
      var _this3 = this;

      var distTag = void 0;
      for (var key in httpRequest.body["dist-tags"]) {
        distTag = key;
      }var packageName = httpRequest.body._packageName;
      var packageScope = httpRequest.body._scope;
      var packageData = httpRequest.body;

      this.packageValidator.hasDistTag({
        name: packageName,
        scope: packageScope
      }, distTag).then(function (hasDistTag) {
        if (hasDistTag === true) {
          _this3.packageValidator.isVersionHigher({
            name: packageName,
            scope: packageScope,
            version: packageData["dist-tags"][distTag]
          }, distTag).then(function (result) {
            if (result === false) {
              httpResponse.send("Cannot publish, given version already exists or is invalid");
            } else {
              _this3.storage.writePackage({
                name: packageName,
                scope: packageScope
              }, packageData).then(function (result) {
                if (result === true) {
                  httpResponse.status(201);
                  httpResponse.send({
                    ok: "package published"
                  });
                } else {
                  httpResponse.status(500);
                  httpResponse.send({
                    message: "Error while writing package"
                  });
                }
              });
            }
          });
        } else {
          httpResponse.status(403);
          httpResponse.send("Cannot publish, given version already exists or is invalid");
        }
      });
    }
  }, {
    key: "writeNewPackage",
    value: function writeNewPackage(httpRequest, httpResponse) {
      var packageName = httpRequest.body._packageName;
      var packageScope = httpRequest.body._scope;
      this.storage.writeNewPackage({
        name: packageName,
        scope: packageScope
      }, httpRequest.body).then(function (result) {
        if (result === true) {
          httpResponse.status(201);
          httpResponse.send({
            ok: "package published"
          });
        } else {
          httpResponse.status(500);
          httpResponse.send({ message: "Error while writing package" });
        }
      });
    }
  }]);

  return _class;
}();

exports.default = _class;