'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _removePackage2 = require('./utils/remove-package');

var _removePackage3 = _interopRequireDefault(_removePackage2);

var _removePackageVersion2 = require('./utils/remove-package-version');

var _removePackageVersion3 = _interopRequireDefault(_removePackageVersion2);

var _getPackage2 = require('./utils/get-package');

var _getPackage3 = _interopRequireDefault(_getPackage2);

var _getPackageJson2 = require('./utils/get-package-json');

var _getPackageJson3 = _interopRequireDefault(_getPackageJson2);

var _isPackageAvailable2 = require('./utils/is-package-available');

var _isPackageAvailable3 = _interopRequireDefault(_isPackageAvailable2);

var _isVersionAvailable2 = require('./utils/is-version-available');

var _isVersionAvailable3 = _interopRequireDefault(_isVersionAvailable2);

var _updatePackagejson = require('./utils/update-packagejson');

var _updatePackagejson2 = _interopRequireDefault(_updatePackagejson);

var _writePackage2 = require('./utils/write-package');

var _writePackage3 = _interopRequireDefault(_writePackage2);

var _writeNewPackage2 = require('./utils/write-new-package');

var _writeNewPackage3 = _interopRequireDefault(_writeNewPackage2);

var _getPackageListing2 = require('./utils/get-package-listing');

var _getPackageListing3 = _interopRequireDefault(_getPackageListing2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(config, logger) {
    _classCallCheck(this, _class);

    this.config = config;
    this.logger = logger;
    this.storageLocation = _path2.default.join(this.config.workDir, this.config.storage.directory);
  }

  /**
   * @param {object} request {name: ?, scope: ?}
   * @return {Boolean} package removed
   */


  _createClass(_class, [{
    key: 'removePackage',
    value: function removePackage(request) {
      return (0, _removePackage3.default)(request, this.storageLocation);
    }

    /**
     * @param {object} request {name: ?, scope: ?, version: ?}
     * @return {Boolean} package version removed
     */

  }, {
    key: 'removePackageVersion',
    value: function removePackageVersion(request) {
      return (0, _removePackageVersion3.default)(request, this.getPackageJson, this.updatePackageJson, this.removePackage, this.storageLocation);
    }

    /**
     * @param {object} request {name: ?, scope: ?, file: ?}
     * @param {object} packageData - The package.json
     * @return {Boolean} new package written
     */

  }, {
    key: 'writeNewPackage',
    value: function writeNewPackage(request, packageData) {
      return (0, _writeNewPackage3.default)(request, packageData, this.storageLocation, this.logger);
    }

    /**
     * @param {object} request {name: ?, scope: ?, file: ?}
     * @param {object} packageData - The package.json
     * @return {Boolean} package written
     */

  }, {
    key: 'writePackage',
    value: function writePackage(request, packageData) {
      return (0, _writePackage3.default)(request, packageData, this.storageLocation, this.logger);
    }

    /**
     * @param {object} request {name: ?, scope: ?}
     * @return {Buffer} package file buffer
     */

  }, {
    key: 'getPackage',
    value: function getPackage(request) {
      return (0, _getPackage3.default)(request, this.storageLocation);
    }

    /**
     * @param {object} request {name: ?, scope: ?}
     * @return {object} package.json object
     */

  }, {
    key: 'getPackageJson',
    value: function getPackageJson(request) {
      return (0, _getPackageJson3.default)(request, this.storageLocation);
    }

    /**
     * @param {object} request {name: ?, scope: ?}
     * @return {Boolean} isPackageAvailable
     */

  }, {
    key: 'isPackageAvailable',
    value: function isPackageAvailable(request) {
      return (0, _isPackageAvailable3.default)(request, this.storageLocation);
    }

    /**
     * @param {object} request {name: ?, scope: ?, version: ?}
     * @return {Boolean} isVersionAvailable
     */

  }, {
    key: 'isVersionAvailable',
    value: function isVersionAvailable(request) {
      return (0, _isVersionAvailable3.default)(request, this.storageLocation);
    }

    /**
     * @param {object} request {name: ?, scope: ?}
     * @param {object} packageJson package.json to update with
     * @return {Boolean} package.json updated
     */

  }, {
    key: 'updatePackageJson',
    value: function updatePackageJson(request, packageJson) {
      return (0, _updatePackagejson2.default)(request, packageJson, this.storageLocation);
    }

    /**
     * @returns {object} listing of available packages
     */

  }, {
    key: 'getPackageListing',
    value: function getPackageListing() {
      return (0, _getPackageListing3.default)(this.storageLocation);
    }
  }]);

  return _class;
}();

exports.default = _class;