'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (storageLocation) {
  return new Promise(function (resolve) {
    var storageListing = {};

    _fs2.default.readdirSync(storageLocation).forEach(function (part) {
      if (part.indexOf('@') !== -1) {
        if (!storageListing.hasOwnProperty(part)) {
          storageListing[part] = {};
        }

        _fs2.default.readdirSync(_path2.default.join(storageLocation, part)).forEach(function (scopedPart) {
          var scopedLocation = _path2.default.join(storageLocation, part, scopedPart);

          if (_fs2.default.lstatSync(scopedLocation).isDirectory()) {
            if (!storageListing[part].hasOwnProperty(scopedPart)) {
              storageListing[part][scopedPart] = {};
            }

            storageListing[part][scopedPart] = getVersions(scopedLocation);
          }
        });
      } else {
        var location = _path2.default.join(storageLocation, part);
        storageListing[part] = getVersions(location);
      }
    });

    resolve(storageListing);
  });
};

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getVersions = function getVersions(packageLocation) {
  var versionArray = [];
  var packageJson = JSON.parse(_fs2.default.readFileSync(_path2.default.join(packageLocation, 'package.json')));

  var versions = packageJson.versions;
  for (var key in versions) {
    if (versions.hasOwnProperty(key)) {
      versionArray.push(key);
    }
  }
  return versionArray;
};