'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (request, storageLocation) {
  return new Promise(function (resolve) {
    var packageName = request.name;
    var packageScope = request.scope;
    var packageVersion = request.version;
    var packageInfoLocation = void 0;

    if (packageScope) {
      packageInfoLocation = _path2.default.join(storageLocation, packageScope, packageName, 'package.json');
    } else {
      packageInfoLocation = _path2.default.join(storageLocation, packageName, 'package.json');
    }

    (0, _readJson2.default)(packageInfoLocation).then(function (packageJSON) {
      var versionExists = false;
      var fileName = void 0;

      for (var version in packageJSON.versions) {
        if (version === packageVersion) {
          versionExists = true;
        }
      }

      if (packageScope) {
        fileName = packageName.substr(packageScope.length + 1);
      } else {
        fileName = packageName;
      }

      var fileExists = void 0;
      if (packageScope) {
        fileExists = _fs2.default.existsSync(_path2.default.join(storageLocation, packageScope, packageName, packageName + '-' + packageVersion + '.tgz'));
      } else {
        fileExists = _fs2.default.existsSync(_path2.default.join(storageLocation, packageName, fileName + '-' + packageVersion + '.tgz'));
      }

      // Both have to be true for the version requested to be available
      resolve(versionExists && fileExists);
    });
  }).catch(function () {
    return false;
  });
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _readJson = require('./read-json');

var _readJson2 = _interopRequireDefault(_readJson);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }