'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (request, packageData, storageLocation, logger) {
  return new Promise(function (resolve) {
    var packageName = request.name;
    var packageScope = request.scope;
    var attachmentName = void 0;
    var folderPath = void 0;
    var packageJsonPath = void 0;
    var filePath = void 0;
    for (var key in packageData._attachments) {
      attachmentName = key;
    }

    if (packageScope) {
      folderPath = _path2.default.join(storageLocation, packageScope, packageName);
      filePath = _path2.default.join(folderPath, attachmentName.substr(packageScope.length + 1));
    } else {
      folderPath = _path2.default.join(storageLocation, packageName);
      filePath = _path2.default.join(folderPath, attachmentName);
    }

    _fsExtra2.default.mkdirsSync(folderPath);
    packageJsonPath = _path2.default.join(folderPath, 'package.json');

    _fs2.default.writeFileSync(filePath, Buffer.from(packageData._attachments[attachmentName].data, 'base64'), { 'mode': '0777' });
    var packageJSON = packageData;
    delete packageJSON._attachments;

    (0, _writeJson2.default)(packageJsonPath, packageJSON).then(function (result) {
      if (packageScope) {
        logger.info("Published package: " + packageScope + '/' + packageName);
      } else {
        logger.info("Published package: " + packageName);
      }
      resolve(result);
    });
  });
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _writeJson = require('./write-json');

var _writeJson2 = _interopRequireDefault(_writeJson);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }