'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = function (req, res, next) {
  var url = decodeURIComponent(req.url);
  var splitUrl = url.split('/');
  var scope = void 0;
  var packageName = void 0;
  var requestedFile = void 0;

  if (_typeof(req.body) !== 'object') {
    req.body = { "npm-args": req.body };
  }

  if (splitUrl[2] === 'package') {
    if (splitUrl[3].indexOf('@') !== -1) {
      req.body._scope = splitUrl[3];
      req.body._packageName = splitUrl[4];
      if (splitUrl[5] === 'dist-tags' && !!splitUrl[6]) {
        req.body._disttag = splitUrl[6];
      }
    } else {
      req.body._packageName = splitUrl[3];
      if (splitUrl[4] === 'dist-tags' && !!splitUrl[5]) {
        req.body._disttag = splitUrl[5];
      }
    }
    next();
    return;
  }

  for (var i = 0; i < splitUrl.length; i++) {
    if (splitUrl[i].indexOf('@') !== -1) {
      if (scope) continue;
      scope = splitUrl[i];
      packageName = splitUrl[i + 1];
    }
  }

  if (scope) {
    for (var _i = 0; _i < splitUrl.length; _i++) {
      if (splitUrl[_i].indexOf('-') !== -1) {
        if (_i <= 2) continue;
        if (requestedFile) continue;
        requestedFile = splitUrl[_i + 2];
      }
    }
  } else {
    for (var _i2 = 0; _i2 < splitUrl.length; _i2++) {
      if (splitUrl[_i2].indexOf('-') !== -1) {
        if (_i2 <= 1) continue;
        if (requestedFile) continue;
        requestedFile = splitUrl[_i2 + 1];
      }
    }
  }

  if (scope && packageName) {
    req.body._scope = scope;
    req.body._packageName = packageName;
    req.body._scopedName = '/' + scope + '/' + packageName;
  } else {
    for (var _i3 = 0; _i3 < splitUrl.length; _i3++) {
      if (req.body._packageName) continue;
      if (splitUrl[_i3] !== '') {
        req.body._packageName = splitUrl[_i3];
        if (splitUrl[_i3 + 1] === '-') {
          requestedFile = splitUrl[_i3 + 2];
        }
      }
    }
  }

  if (requestedFile) {
    req.body._requestedFile = requestedFile;
  }

  if (packageName) {
    req.url = '/' + packageName;
    if (requestedFile) {
      req.url += '/-/' + requestedFile;
    }
  }

  next();
};