'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
  function _class(storage) {
    _classCallCheck(this, _class);

    this.storage = storage;
  }

  /**
   * @param {Object} request {name: ?, scope: ?, version: ?}
   * @param {String} distTag dist-tag to check
   * @returns {Boolean} version is higher
   */


  _createClass(_class, [{
    key: 'isVersionHigher',
    value: function isVersionHigher(request, distTag) {
      var _this = this;

      var packageName = request.name;
      var packageVersion = request.version;
      var packageScope = request.scope;

      return new Promise(function (resolve) {
        _this.storage.getPackageJson({
          name: packageName,
          scope: packageScope
        }).then(function (packageJson) {
          var currentVersion = packageJson['dist-tags'][distTag];
          resolve(_semver2.default.satisfies(packageVersion, '>' + currentVersion));
        });
      });
    }

    /**
     * @param {Object} request {name: ?, scope: ?, version: ?}
     * @param {String} distTag dist-tag to check
     * @returns {Boolean} package has dist-tag
     */

  }, {
    key: 'hasDistTag',
    value: function hasDistTag(request, distTag) {
      var _this2 = this;

      var packageName = request.name;
      var packageScope = request.scope;

      return new Promise(function (resolve) {
        _this2.storage.getPackageJson({
          name: packageName,
          scope: packageScope
        }).then(function (packageJson) {
          resolve(!!packageJson['dist-tags'][distTag]);
        });
      });
    }
  }]);

  return _class;
}();

exports.default = _class;